#!/usr/bin/env cwl-runner
cwlVersion: v1.2
class: Workflow

requirements:
  ScatterFeatureRequirement: {}
  SubworkflowFeatureRequirement: {}
  MultipleInputFeatureRequirement: {}

inputs:
  inKallistoResults: Directory
  inMetadataFile: File
  inMetadataSample: string
  inMetadataFactorList: string[]
  finaloutdir: string
 
steps:
  deseq2:
    run: deseq2.cwl
    in:
      inKallistoResults: inKallistoResults
      inMetadataFile: inMetadataFile
      inMetadataSample: inMetadataSample
      inMetadataFactorList: inMetadataFactorList
    out:
      - results_stats
      - results_ma-plot
      - results_pca-plot
  collectFiles:
    run: ./gather-files.cwl
    in: 
      inFiles:
        source:
          - deseq2/results_stats
          - deseq2/results_ma-plot
          - deseq2/results_pca-plot
        linkMerge: merge_flattened
      destination: finaloutdir
    out: [outDir]
  
outputs:
  deseq2_outdir:
    type: Directory
    outputSource: collectFiles/outDir

$namespaces:
  s: https://schema.org/
  edam: http://edamontology.org/

$schemas:
  - https://schema.org/version/latest/schemaorg-current-https.rdf
  - http://edamontology.org/EDAM_1.18.owl

s:author:
  - class: s:Person
    s:name: Dominik Brilhaus
    s:identifier: https://orcid.org/0000-0001-9021-3197
